module Example where

import OP
import Temp
import AST
import AST2IR
import Blocks
import MaxMunge
import Instr

-- code for
{-
  i = 0;
  r = 0;
  while (i<n) {
    r = r + 2*i;
    i = i + 1;
  }
-}
-- |abstract syntax tree
ast =
    Assign 0 (Const 0) `SEQ`
    Assign 1 (Const 0) `SEQ`
    While (Relop Lt (Var 0) (Var 2)) (
        Assign 1 (Binop Add (Var 1) (Binop Mul (Const 2) (Var 0))) `SEQ`
        Assign 0 (Binop Add (Var 0) (Const 1)))
-- |intermediate representation
ir =
   runTM 100 (forProgram ast)
-- |list of basic blocks
bbs =
    basicBlocks ir
-- |list of traces
trcs = 
    traces bbs
-- |list of adjusted traces
trcsOpt =
    map traceOpt trcs
-- |generated instruction sequence
instrs =
    runTM 500 $ gen (concat trcsOpt)
