module Instr where

import Data.Char
import qualified IR

data T
     = OPER String [IR.Temp] [IR.Temp]
     | MOVE String [IR.Temp] [IR.Temp]
     | LABEL IR.Label
     deriving Show

out :: T -> String
out (OPER tpl targets sources) =
    ' ' : instantiate tpl targets sources
out (MOVE tpl targets sources) =
    ' ' : instantiate tpl targets sources
out (LABEL label) =
    "L" ++ show label ++ ":"

instantiate :: String -> [IR.Temp] -> [IR.Temp] -> String
instantiate [] targets sources = ""
instantiate ('\'': 'd': cn: rest) targets sources | isDigit cn = "r" ++ show (targets !! (ord cn - ord '0')) ++ instantiate rest targets sources
instantiate ('\'': 's': cn: rest) targets sources | isDigit cn = "r" ++ show (sources !! (ord cn - ord '0')) ++ instantiate rest targets sources
instantiate (c: rest) targets sources = c: instantiate rest targets sources
