module Temp where

import qualified IR

class Monad m => TMonad m where
    newLabel :: m IR.Label
    newTemp  :: m IR.Temp

--

data TM a = TM { unTM :: IR.Label -> (a, IR.Label) }
instance Monad TM where
  return a = TM (\x -> (a, x))
  TM fa >>= gb = TM (\x -> let (a, x') = fa x in unTM (gb a) x')

instance TMonad TM where
  newLabel = TM (\x -> (x, x+1))
  newTemp  = TM (\x -> (x, x+1))

runTM :: Int -> TM a -> a
runTM n ta = fst $ unTM ta n

